<template>
  <div class="flex flex-col justify-start w-full mb-4">
    <div class="flex flex-row justify-between items-start mb-1 mt-2">
      <div class="flex flex-col md:flex-row lg:flex-col xl:flex-row">
        <h3 class="py-2 [&&]:text-xs sm:!text-sm">Zeitraum (nach Ordenszugehörigkeit)</h3>
        <div :class="['flex mr-auto items-center mb-[-1rem] md:mb-0 lg:mb-[-1rem] xl:mb-0 md:ml-6 lg:ml-0 xl:ml-6', selectedRange[0] <= selectedRange[1] ? 'flex-row' : 'flex-row-reverse']">
          <InputNumber 
            v-model.number="selectedRange[0]" 
            :min="timeRange.start" 
            :max="timeRange.end" 
            size="small" 
            :format="false"
            @update:modelValue="(value) => onInputChange([value, selectedRange[1]])"
            inputClass="w-16 h-8"
          />
          <span class="mx-2">-</span>
          <InputNumber 
            v-model.number="selectedRange[1]" 
            :min="timeRange.start" 
            :max="timeRange.end" 
            size="small" 
            :format="false"
            @update:modelValue="(value) => onInputChange([selectedRange[0], value])"
            inputClass="w-16 h-8"
          />
        </div>
      </div>
      <div class="flex justify-center items-center">
        <Button 
          v-if="isRangeSelected"
          @click="resetRange"
          text 
          size="small"
          class="mr-1"
          >zurücksetzen
        </Button>
        <Button 
          small
          close
          @click="visible = false"
          unstyled
          :pt="{
            root: {
              class: 'border-none rounded-full mr-[-8px] w-[36px] h-[36px] flex justify-center items-center hover:bg-gray-200'
            }
          }"
          >
          <span class="pi pi-times text-sm text-gray-500"></span>
        </Button>
      </div>
    </div>
    <div ref="chart" class="h-[69px] overflow-hidden"></div>
    <Slider 
      v-model="selectedRange" 
      :min="timeRange.start" 
      :max="timeRange.end" 
      :step="gap"
      @change="updateBarColors"
      @slideend="(event) => search(event.value)"
      range
      class="mb-2 mt-[-1.25rem] ml-[10px] mr-[30px]"
      />
  </div>  
</template>

<script setup>
import { useStore } from 'vuex'
import { computed, ref, onMounted, onUnmounted, nextTick, watch, useModel } from 'vue'
import Slider from 'primevue/slider'
import InputNumber from 'primevue/inputnumber'
import Button from 'primevue/button'
import * as d3 from 'd3';

const store = useStore();

const visible = defineModel('visible');

const chart = ref(null);
const selectedRange = ref([null, null]);
const inputFieldsReversed = ref(false);

const dimension = ref({ width: 0, height: 0 });
const margin = {top: 5, right: 30, bottom: 20, left: 10};

const tooltip = ref(null);

let resizeObserver = null;

const gap = computed(() => store.state.histogramOptions.gap);
const hist = computed(() => store.state.histogram);
const timeRange = computed(() => store.state.initialTimeRange);
const globalSearchQuery = computed(() => store.state.monasteriesQuery.search);

const isRangeSelected = computed(() => {
  const { start, end } = getStartEnd(selectedRange.value);
  return start !== timeRange.value.start || end !== timeRange.value.end;
});

const startFieldName = 'dissolutionAfter';
const endFieldName = 'foundationBefore';

watch(timeRange, () => {
  setSelectedRange();
});

watch(hist, () => computeDimensionAndRender());

function getStartEnd(range) {
  const ascending = range[0] <= range[1];
  const start = ascending ? range[0] : range[1];
  const end = ascending ? range[1] : range[0];
  return { start, end };
}

function resetRange() {
  selectedRange.value = [timeRange.value.start, timeRange.value.end];
  computeDimensionAndRender();
  search(selectedRange.value);
}

function setSelectedRange() {
  let start = globalSearchQuery.value?.find(term => term.field === startFieldName)?.value ?? timeRange.value.start ?? null;
  let end = globalSearchQuery.value?.find(term => term.field === endFieldName)?.value ?? timeRange.value.end ?? null;
  if (typeof start === "string") {
    start = parseInt(start);
  }
  if (typeof end === "string") {
    end = parseInt(end);
  }
  selectedRange.value = [
    start,
    end
  ]
  computeDimensionAndRender();
}

function onInputChange(range) {
  range[0] = range[0] ?? (inputFieldsReversed.value ? timeRange.value.end : timeRange.value.start);
  range[1] = range[1] ?? (inputFieldsReversed.value ? timeRange.value.start : timeRange.value.end);
  selectedRange.value = range;
  search(range);
}

function search([start, end]) {
  inputFieldsReversed.value = start > end;
  if (inputFieldsReversed.value) {
    [start, end] = [end, start];
  }
  const searchQuery = isRangeSelected.value ? buildQuery(start, end) : clearQuery();
  const keepFacets = true;
  if (!isHistogramSearchQueryEqual(searchQuery, globalSearchQuery.value)) {
    store.dispatch('search', { searchQuery, keepFacets});
  }
}

//equality check, only for search fields that the histogram sets
function isHistogramSearchQueryEqual (searchQuery1, searchQuery2) {
  const isEqualField = (fieldname) => {
    const value1 = searchQuery1.find(item => item.field === fieldname)?.value;
    const value2 = searchQuery2.find(item => item.field === fieldname)?.value;
    return ((typeof value1 === 'undefined' && typeof value2 === 'undefined') || value1 === value2);
  }
  if (searchQuery1 === null && searchQuery2 === null) {
    return true;    
  } 
  if (searchQuery1 === null || searchQuery2 === null) {
    return false;
  }
  return isEqualField(startFieldName) && isEqualField(endFieldName);
}

function buildQuery(start, end) {
  const query = globalSearchQuery.value;
  const localQuery = query === null ? [] : query.map(item => { return {...item}}); //copy to avoid changing the global query
  const queryWithStart = getUpdatedSearchQuery(startFieldName, start, localQuery);
  return getUpdatedSearchQuery(endFieldName, end, queryWithStart);
}

//only clear fields set by the slider
function clearQuery() {
  const query = globalSearchQuery.value;
  if (query === null) {
    return null;
  }
  const newQuery = query.filter(item => item.field !== startFieldName && item.field !== endFieldName);
  return newQuery.length > 0 ? newQuery : null;
}

function getUpdatedSearchQuery(field, value, query) {
  if (query === null) {
    query = [];
  }
  const index = query.findIndex(item => item.field === field)
  if (index < 0) {
    query.push({
      'field': field,
      'value': `${value}`,
      'operator': 'eq'
    })
  }
  else {
    query[index]['value'] = `${value}`;
  }
  return query;  
}

//fills missing keys to avoid wrong scaling
function fillMissingData(data, gap) {
  //ensure max range
  if (timeRange.value.start && timeRange.value.end) {
    if (data.length === 0 || data[0].startLabel > timeRange.value.start) {
      data.unshift({
        startLabel: timeRange.value.start,
        count: 0
      })
    }
    if (data[data.length - 1].startLabel < (timeRange.value.end - gap)) {
      data.push({
        startLabel: timeRange.value.end - gap,
        count: 0
      })
    }
  }
  const filled = []
  for (let i = 1; i < data.length; i++) {
    filled.push(data[i - 1]);
    while ((filled[filled.length - 1].startLabel + gap) < data[i].startLabel) {
      filled.push({
        startLabel: filled[filled.length - 1].startLabel + gap,
        count: 0
      })
    }
  }
  filled.push(data[data.length - 1]);
  return filled;
}

const isInRange = (d) => {
    const { start, end } = getStartEnd(selectedRange.value);
    return (d.startLabel >= start) && (d.startLabel < end);
  };

const barFill = (d) => isInRange(d) ?  "fill-primary-200" : "fill-gray-400";
const barFillHover = (d) => isInRange(d) ?  "fill-primary-700" : "fill-gray-700";  

const updateBarColors = () => {
  d3.select(chart.value)
    .select('svg')
    .select('g')
    .select('#all-bars')
    .selectAll('rect')
    .attr("class", function(d) { return barFill(d); });
}


const render = () => {
  d3.select(chart.value).selectAll('svg').remove();

  const width = dimension.value.width;
  const height = dimension.value.height;

  
  const dataTransformed = hist.value.map(d => ({ 
    ...d,
    startLabel: parseInt(d.startLabel)
  }));

  const data = fillMissingData(dataTransformed, gap.value);

  const numBars = data.length;
  const barWidth = width / numBars;

  const x = d3.scaleLinear()
    .range([0, width])
  const y = d3.scaleLinear()
    .range([height, 0]);

  x.domain([data[0].startLabel, data[numBars - 1].startLabel]);
  y.domain([0, Math.max(1, d3.max(data, d => d.count))]);

  if (!tooltip.value) {
    tooltip.value = d3.select(chart.value).append("div")  
      .attr("class", "bg-white rounded px-2 py-1 border-2 text-sm absolute z-[9999]")    
      .style("visibility", "hidden");
  }

  const showTooltip = (d, parentId) => {
    d3.select(parentId) 
      .attr("class", barFillHover(d));
    tooltip.value
      .html("<div>Jahr: " + d.startLabel + "<br>Klöster: " + d.count + "</div>")
      .style("visibility", "visible");
  }

  const hideTooltip = (d, parentId) => {
    d3.select(parentId)
      .attr("class", barFill(d));
    tooltip.value     
      .style("visibility", "hidden");
  }

  const setTooltipPosition = (event, svgNode) => {
    const [relativeX, relativeY] = d3.pointer(event, svgNode);
    tooltip.value
      .style("top", (relativeY) + "px")
      .style("left", (relativeX) + "px");
  }
  
  const svg = d3.select(chart.value)
    .append("svg")
      .attr("width", width + margin.left + margin.right)
      .attr("height", height + margin.top + margin.bottom)
      .append("g")
      .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

  const chartGroup = svg.append("g")
    .attr("id", "all-bars")

  const bars = chartGroup.selectAll(".bar")
    .data(data)
    .enter().append("rect")
      .attr("id", function (d) { return "bar-" + d.startLabel})
      .attr("x", function(d, i) { return i * barWidth})
      .attr("width", barWidth)
      .attr("y", function(d) { return y(d.count); })
      .attr("height", function(d) { return height - y(d.count); })
      .attr("class", function(d) { return barFill(d); });
  
  const hoverChartGroup = svg.append("g")
  
  const hoverBars = hoverChartGroup.selectAll(".hoverBar")
    .data(data)
    .enter().append("rect")
    .attr("x", function(d, i) { return i * barWidth})
    .attr("width", barWidth)
    .attr("y", 0)
    .attr("height", height)
    .attr("class", "fill-transparent")

  hoverBars
    .on("mouseover", function(event, d) {
      showTooltip(d, "#bar-" + d.startLabel);
    })
    .on("mousemove", function(event, d) {
      setTooltipPosition(event, svg.node());
    })                  
    .on("mouseout", function(event, d) {       
      hideTooltip(d, "#bar-" + d.startLabel); 
    });

  const xAxisGroup = svg.append("g")
    .attr("transform", "translate(0," + (height + 3) + ")")
    .attr("class", "text-gray-500");
  
  const yAxisGroup = svg.append("g")
    .attr("transform", "translate(" + (width + margin.right) + ", 0)")
    .attr("class", "text-gray-500");

  const drawAxis = (xScale, yScale) => {
    xAxisGroup.call(d3.axisBottom(xScale).ticks(12).tickFormat(d => parseInt(d)));
    yAxisGroup.call(d3.axisLeft(yScale).ticks(2).tickSize(0).tickFormat(d => parseInt(d)));
    xAxisGroup.selectAll("path", "line").remove();
    yAxisGroup.selectAll("path", "line").remove();
  };

  drawAxis(x, y);

}

const computeDimensionAndRender = () => {
  if (chart.value) {
    dimension.value.width = chart.value.clientWidth - margin.left - margin.right;
    dimension.value.height = chart.value.clientHeight - margin.top - margin.bottom;
    if(timeRange.value.start && timeRange.value.end) {
      render();
    }
  }
}

onMounted(async () => {
  store.dispatch('getHistogram')
  await nextTick();

  setSelectedRange();
  resizeObserver = new ResizeObserver(computeDimensionAndRender);
  resizeObserver.observe(chart.value);
});

onUnmounted(() => {
  if (tooltip.value) {
    tooltip.value.remove();
  }
  if (resizeObserver) {
    resizeObserver.disconnect();
  }
});

</script>
